package main

import (
	"fmt"
	"strings"
)

func main() {
	var str string

	str = "("
	fmt.Println(isValid(str))

	str = "()"
	fmt.Println(isValid(str))

	str = "()[]{}"
	fmt.Println(isValid(str))

	str = "(]"
	fmt.Println(isValid(str))

	str = "([)]"
	fmt.Println(isValid(str))

	str = "{[]}"
	fmt.Println(isValid(str))

	str = "]{[]}"
	fmt.Println(isValid(str))

	str = "{[]}}"
	fmt.Println(isValid(str))
}

func isValid(s string) bool {
	for {
		if !strings.Contains(s, "()") && !strings.Contains(s, "[]") && !strings.Contains(s, "{}") {
			break
		}
		s = strings.Replace(s, "()", "", -1)
		s = strings.Replace(s, "[]", "", -1)
		s = strings.Replace(s, "{}", "", -1)
	}
	return s == ""
}
